''' <summary>
''' Definiert Eigenschaften einer Datei
''' </summary>
''' <remarks></remarks>
Public MustInherit Class DateiDefinition

    ' die nchsten vier Felder werden im DateiManager mit gebeugten Begriffen 
    ' zur Verwendung in Meldungen festgelegt
    Private m_Txt_diegeoeffneteDatei As String ' = "die geffnete Zeichnung"
    ' Text-Entsprechung fr Anrede des Dokuments 
    ' (Erster Buchstabe gross geschrieben) mit "Dieser", "Diese", "Dieses"...
    Private m_Txt_DieseDatei As String ' = "Diese Zeichnung"
    ' Entsprechung mit "ein", "eine", "ein"
    Private m_Txt_eineDatei As String ' = "eine Zeichnung"
    ' Pronom fr Datei-Bezeichnung im 4.Fall Einzahl ("ihn", "sie", "es")
    Private m_Txt_sie As String ' = "sie"

    ''' <summary>
    ''' Anwendungs-Titel
    ''' </summary>
    MustOverride ReadOnly Property AppTitle() As String
    ''' <summary>
    ''' Kurztitel fr Anwendung zur Verwendung in der Registry
    ''' </summary>
    MustOverride ReadOnly Property AppShortTitle() As String
    ''' <summary>
    ''' Einfacher Name fr ein Dokument 
    ''' </summary>
    MustOverride ReadOnly Property DocumentName() As String
    ''' <summary>
    ''' Mehrzahl fr Dokument-Bezeichnung
    ''' </summary>
    MustOverride ReadOnly Property DocumentsName() As String
    ''' <summary>
    ''' relativer Pfad+ Dateiname des Anwendungs-Icons zur Exe
    ''' </summary>
    MustOverride ReadOnly Property IconFileName() As String
    ''' <summary>
    ''' Erweiterung / Endung fr den Dateinamen
    ''' </summary>
    MustOverride ReadOnly Property Extension() As String
    ''' <summary>
    ''' Name eines eigenen Ordners im Dokumenten-Directory, das als Standard-Verzeichnis verwendet wird
    ''' </summary>
    MustOverride ReadOnly Property PersonalFolderName() As String
    ''' <summary>
    ''' Geschlecht des Dokument-Namens
    ''' </summary>
    MustOverride ReadOnly Property Geschlecht() As Geschlechter

    Property Txt_diegeoeffneteDatei() As String
        Get
            Return m_Txt_diegeoeffneteDatei
        End Get
        Set(ByVal value As String)
            m_Txt_diegeoeffneteDatei = value
        End Set
    End Property
    Property Txt_DieseDatei() As String
        Get
            Return m_Txt_DieseDatei
        End Get
        Set(ByVal value As String)
            m_Txt_DieseDatei = value
        End Set
    End Property
    Property Txt_eineDatei() As String
        Get
            Return m_Txt_eineDatei
        End Get
        Set(ByVal value As String)
            m_Txt_eineDatei = value
        End Set
    End Property
    Property Txt_sie() As String
        Get
            Return m_Txt_sie
        End Get
        Set(ByVal value As String)
            m_Txt_sie = value
        End Set
    End Property
    ''' <summary>
    ''' liefert eine neue Datei
    ''' </summary>
    ''' <param name="FileName">Pfad oder leer fr neue Datei</param>
    MustOverride Function CreateFile(ByVal FileName As String) As Datei

    ''' <summary>
    ''' liefert eine Windows Form zur Datei
    ''' </summary>
    MustOverride Function CreateForm() As System.Windows.Forms.Form
End Class
