Imports Dateiverwaltung
''' <summary>
''' Definiert Eigenschaften einer Bilddatei
''' </summary>
Public Class BildDateiDefinition
    Inherits DateiDefinition
    ' Hier sind enthalten
    ' a) Informationen fr Texte in MessageBoxes
    ' b) Datei-Endung, Icon, Datei-Name

    ' Nur die privaten Felder hier, und der Datei-Typ bei CreateFile 
    ' mssten bei eigener Implementierung angepasst werden.
    ' Der an Stelle dieser Klasse neu erstellte Typ muss 
    ' in ApplicationEvents im Property Manager angegeben werden.

    ' Anwendungs-Titel
    Private m_AppTitle As String = "PixelPainter"
    ' Kurztitel fr Anwendung zur Verwendung in der Registry
    Private m_AppShortTitle As String = "PixelPainter"
    ' Einfacher Name fr ein Dokument (z.B. "Datei", "Dokument", "Blatt")
    Private m_DocumentName As String = "Zeichnung"
    ' Mehrzahl fr Dokument-Bezeichnung
    Private m_DocumentsName As String = "Zeichnungen"
    ' relativer Pfad+ Dateiname des Anwendungs-Icons zur Exe
    Private m_IconFileName As String = "PixelPaintdoc.ico"
    ' gewnschte Erweiterung / Endung fr den Dateinamen
    Private m_Extension As String = ".ppt_xml"
    ' Name eines eigenen Ordners im Dokumenten-Directory, das als Standard-Verzeichnis
    ' zum Speichern der Dokumente verwendet werden soll
    Private m_PersonalFolderName As String = "PixelPainter"
    ' Geschlecht des Dokument-Namens (maennlich, weiblich oder saechlich)
    Private m_Geschlecht As Geschlechter = Geschlechter.weiblich

    ''' <summary>
    ''' Mit dieser Methode liefert die Datei-Definition eine neue Datei
    ''' </summary>
    ''' <param name="FileName">Pfad der Datei oder leer fr neues Dokument</param>
    Public Overrides Function CreateFile(ByVal FileName As String) As Datei
        Return New BildDatei(FileName)
    End Function
    Public Overrides Function CreateForm() As System.Windows.Forms.Form
        Return New frm_PixelPainter
    End Function

#Region " Properties "

    ''' <summary>
    ''' Anwendungs-Titel
    ''' </summary>
    Public Overrides ReadOnly Property AppTitle() As String
        Get
            Return m_AppTitle
        End Get
    End Property

    ''' <summary>
    ''' Kurztitel fr Anwendung zur Verwendung in der Registry
    ''' </summary>
    Public Overrides ReadOnly Property AppShortTitle() As String
        Get
            Return m_AppShortTitle
        End Get
    End Property

    ''' <summary>
    ''' Einfacher Name fr ein Dokument (z.B. "Datei", "Dokument", "Blatt")
    ''' </summary>
    Public Overrides ReadOnly Property DocumentName() As String
        Get
            Return m_DocumentName
        End Get
    End Property

    ''' <summary>
    ''' Mehrzahl fr Dokument-Bezeichnung
    ''' </summary>
    Public Overrides ReadOnly Property DocumentsName() As String
        Get
            Return m_DocumentsName
        End Get
    End Property

    ''' <summary>
    ''' relativer Pfad+ Dateiname des Anwendungs-Icons zur Exe
    ''' </summary>
    Public Overrides ReadOnly Property IconFileName() As String
        Get
            Return m_IconFileName
        End Get
    End Property

    ''' <summary>
    ''' Erweiterung / Endung fr den Dateinamen
    ''' </summary>
    Public Overrides ReadOnly Property Extension() As String
        Get
            Return m_Extension
        End Get
    End Property

    ''' <summary>
    ''' Name eines eigenen Ordners im Dokumenten-Directory, als Standard-Verzeichnis fr Dokumente verwendet
    ''' </summary>
    Public Overrides ReadOnly Property PersonalFolderName() As String
        Get
            Return m_PersonalFolderName
        End Get
    End Property

    ''' <summary>
    ''' Geschlecht des Dokument-Namens (maennlich, weiblich oder saechlich)
    ''' </summary>
    Public Overrides ReadOnly Property Geschlecht() As Geschlechter
        Get
            Return m_Geschlecht
        End Get
    End Property

#End Region

End Class
