''' <summary>
''' AlignContainer, der um ein enthaltenes Control einen Rahmen zeichnet
''' </summary>
''' <remarks></remarks>
Public Class BorderAlignContainer
    Inherits AlignContainer

    Public Sub New()
        ' DoubleBuffering aktivieren
        Me.SetStyle(ControlStyles.DoubleBuffer Or ControlStyles.UserPaint _
        Or ControlStyles.AllPaintingInWmPaint, True)
        Me.UpdateStyles()
    End Sub

    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(e)
        Dim g As Graphics = e.Graphics

        ' Rahmen um das Inhalts-Rechteck zeichnen
        Dim Orig As Rectangle = MyBase.ContentRectangle
        ControlPaint.DrawVisualStyleBorder(g, New Rectangle(Orig.X - 1, Orig.Y - 1, Orig.Width + 1, Orig.Height + 1))
    End Sub

    Protected Overrides Sub OnResize(ByVal e As System.EventArgs)
        MyBase.OnResize(e)

        ' In diesem Fall ist eine Methode fr Resize erforderlich, um das Rahmenrechteck neu zu zeichnen
        Invalidate()
    End Sub
End Class
