Public Class frm_PixelPainter
    ' diese Form ist ein Erbe von DateiForm
    ' also zuerst den Code dort ansehen

#Region " Private Felder "
    ' Button mit aktiver Farbe
    Private m_ActiveButton As ToolStripButton

    Private WithEvents m_Datei As BildDatei
#End Region

#Region " Properties "

    '''' <summary>
    '''' Fenster-MenueItem
    '''' </summary>
    'Public Overrides ReadOnly Property WindowMenuItem() As System.Windows.Forms.ToolStripMenuItem
    '    Get
    '        ' in der Basisklasse (DateiForm) vorhanden und hier berschrieben
    '        ' liefert das Fenster-Menueitem und gibt dem FileManager die Mglichkeit,
    '        ' bei Aktivierung dieser Form das Fenster-Menue neu zu fllen
    '        Return Me.FensterToolStripMenuItem
    '    End Get
    'End Property

#End Region

#Region " Konstruktor "

    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.

        ' Ein Button ist bei Start gecheckt
        Me.ToolStripButtonRed.Checked = True
        m_ActiveButton = ToolStripButtonRed

        ' eigenen ToolStripRenderer definieren
        Dim MyRenderer As New ToolStripProfessionalRenderer(New MyProfessionalColorTable)
        Me.ToolStrip1.Renderer = MyRenderer
        Me.MenuStrip1.Renderer = MyRenderer
        Me.StatusStrip1.Renderer = MyRenderer
        Me.BackColor = MyRenderer.ColorTable.ToolStripGradientBegin
    End Sub

#End Region

#Region " Methoden "

    ''' <summary>
    ''' zeigt den Datei-Inhalt in der Form neu an
    ''' </summary>
    Private Sub Datei_Lesen()
        ' Es wird nur dem PixelGrid die Datei als Referenz bergeben, 
        ' um's Zeichnen kmmert sich das PixelGrid-Control
        Me.PixelGrid1.Datei = m_Datei
    End Sub

    ''' <summary>
    ''' Ereignet sich bei Click auf einen der Farb-Buttons
    ''' </summary>
    Private Sub ToolStripButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripButtonBlack.Click, ToolStripButtonBlue.Click, ToolStripButtonGreen.Click, ToolStripButtonOrange.Click, ToolStripButtonRed.Click, ToolStripButtonTurquoise.Click, ToolStripButtonWhite.Click, ToolStripButtonYellow.Click
        ' Die Farb-Buttons haben als property CheckOnClick = True
        ' Also muss ich nur noch den vorher aktiven Button vom Checked-State befreien

        Dim NewButton As ToolStripButton = sender
        If m_ActiveButton IsNot NewButton Then
            m_ActiveButton.Checked = False
            m_ActiveButton = NewButton
            ' Jeder Farb-Button hat als Tag seinen ColorIndex,
            ' der wird hier dem PixelGrid bekannt gemacht
            Me.PixelGrid1.ActiveColorIndex = m_ActiveButton.Tag
        End If

    End Sub

    ''' <summary>
    ''' Button zum Lschen des gesamten Datei-Inhalts
    ''' </summary>
    Private Sub ToolStripButtonClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonClear.Click
        ' das PixelGrid hat als ffentliche Methode Clear
        Me.PixelGrid1.Clear()
    End Sub

    ''' <summary>
    ''' Button zum Verknpfen von Dateien mit Anwendung, Icon und Datei-Extension 
    ''' </summary>
    Private Sub ToolStripButtonRegistrieren_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonRegistrieren.Click
        ' Vorwarnung als MessageBox abgeben
        Dim msg As String = "Folgend wird der Dialog der Benutzerkontensteuerung zum Zugriff auf die Registry geffnet. " & _
        "Erst nach Besttigung durch den Benutzer wird der aktuelle Datei-Typ in der Registry vermerkt."
        If MessageBox.Show(msg, Application.ProductName, MessageBoxButtons.OKCancel, MessageBoxIcon.Warning) = Windows.Forms.DialogResult.OK Then
            ' Code zum Registry-Zugriff
            My.Application.Manager.RegisterFileType(Application.StartupPath)
        End If
    End Sub

    Private Sub NeuToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NeuToolStripMenuItem.Click
        ' neue Datei anlegen
        My.Application.Manager.Create_New()
    End Sub

    Private Sub ffnenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ffnenToolStripMenuItem.Click
        ' Datei ffnen
        My.Application.Manager.Open_Dialog()
    End Sub

    Private Sub SpeichernToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SpeichernToolStripMenuItem.Click
        ' Datei speichern
        My.Application.Manager.Save()
    End Sub

    Private Sub SpeichernunterToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SpeichernunterToolStripMenuItem.Click
        ' Datei speichern unter
        My.Application.Manager.Save_As()
    End Sub

    Private Sub SchliessenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SchliessenToolStripMenuItem.Click
        ' Datei schlieen
        Me.Close()
    End Sub

    Private Sub BeendenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BeendenToolStripMenuItem.Click
        ' Datei beenden
        My.Application.Manager.CloseAllForms()
    End Sub

    ''' <summary>
    ''' wenn sich nach speichern der anzeige-Text fr das aktuelle Fenster ndert
    ''' </summary>
    Private Sub m_Datei_FormText_Changed() Handles m_Datei.FormText_Changed
        Me.Text = My.Application.Manager.AnwendungsTitel & " - " & m_Datei.FormText
    End Sub

    ''' <summary>
    ''' beim Laden der Form wird diese im FormsManager registriert und die dazu gehrende
    ''' Datei erstellt.
    ''' </summary>
    Private Sub frm_PixelPainter_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        m_Datei = My.Application.Manager.GetFile(Me)
        Me.Text = My.Application.Manager.AnwendungsTitel & " - " & m_Datei.FormText
        Datei_Lesen()
    End Sub

    ' erstellt die Items im Fenster-Menu neu
    Private Sub FensterToolStripMenuItem_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs) Handles FensterToolStripMenuItem.DropDownOpening
        ' nach DropDown im Fenster-Menu werden Items mit Beschriftung und Referenz zu
        ' allen offenen Datei-Forms in dieses Men eingefgt
        Dim menu As ToolStripMenuItem = CType(sender, ToolStripMenuItem)

        ' Das aktuelle Men bereinigen
        If menu.DropDownItems.Count > 0 Then
            For Each item As ToolStripMenuItem In menu.DropDownItems
                RemoveHandler item.Click, AddressOf FensterMenuItem_Click
            Next
            menu.DropDownItems.Clear()
        End If

        Dim AnwendungsTitel As String = My.Application.Manager.AnwendungsTitel
        Dim TitelLaenge As Integer = AnwendungsTitel.Length + 3

        ' Dieses Men erhlt je ein Item fr jede offene DateiForm
        For Each frm As Form In My.Application.Manager.OpenForms
            Dim item As New ToolStripMenuItem
            item.Text = frm.Text.Substring(TitelLaenge)
            item.Tag = frm
            If frm Is Me Then item.Checked = True
            menu.DropDownItems.Add(item)
            ' einen Handler fr das Click-Ereignis fr dieses Item hinzu fgen
            AddHandler item.Click, AddressOf FensterMenuItem_Click
        Next

    End Sub

    ''' <summary>
    ''' Eventhandler fr das Click-Ereignis auf ein Item im WindowMenu einer DateiForm
    ''' </summary>
    Private Sub FensterMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        ' ausgewhlte Form aktivieren
        CType(CType(sender, ToolStripMenuItem).Tag, Form).Activate()
    End Sub

#End Region

End Class